unit Listdlg;
interface
uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, Forms,
    Listdlgb;
type
    TListBoxDlg = class(TComponent)
    private
       FDlgCaption: String;
       FWidth: Integer;
       FListSorted: Boolean;
       FListContents: TStringList;
       FResultString: String;
       FMyItem: String;
       property ListContents: TStringList read FListContents write FListContents;
    published
       property ResultString: string read FResultString write FResultString;
       property ListSorted: boolean read FListSorted write FListSorted;
       property DlgCaption: string read FDlgCaption write FDlgCaption;
       property Width: integer read FWidth write FWidth;
    public
       constructor Create(Owner: TComponent); override;
       destructor Destroy; override;
       function Execute: Boolean;
       procedure ClearContents;
       procedure AddItem(MyItem: String);
    end;
procedure Register;

implementation

procedure Register;
begin
     RegisterComponents('Daveware', [TListBoxDlg]);
end;

constructor TListBoxDlg.Create(Owner: TComponent);
begin
  inherited Create(Owner);		{ Initialize inherited parts }
  ListContents := TStringList.Create;		{construct the list}
end;

destructor TListBoxDlg.Destroy;
begin
  ListContents.Free;				{destroy the list object}
  inherited Destroy;
end;

procedure TListBoxDlg.ClearContents;
begin
ListContents.Clear;
end;

procedure TListBoxDlg.AddItem(MyItem: String);
begin
ListContents.Add(MyItem);
end;

function TListBoxDlg.Execute: Boolean;
var
   I: Integer;
begin
ListForm := TListForm.Create(Application); { construct List box }
ResultString := '';
try
   if DlgCaption = '' then { if caption is left blank... }
      DlgCaption := Application.Title; { ...use application title instead }
   ListForm.Caption := DlgCaption; { Write caption }
   ListForm.ListBox1.Sorted := ListSorted; {Sort based on sorted property}
   ListForm.ListBox1.Items := ListContents; {Copy strings into list}
   if Width = 0 then Width := 240;
   ListForm.Width := Width;
   I := Width div 2;
   with ListForm do
        begin
        OKButton.Left := (I - 85);
        CancelButton.Left := (I + 8);
        end;
With ListForm do
     begin
     ShowModal;
     if (ModalResult = mrOK) and (ListBox1.ItemIndex <> -1) then
        begin
           Result := True; { execute and set result }
           ResultString := ListBox1.Items.Strings[listbox1.itemindex];
        end
        else Result := False;
     end;

finally
   ListForm.Free; { dispose of List Dialog }
end;
end;


end.
